int lastRead = HIGH;
long lastUpdate = 0;
long lastDeadFlash = 0;
long lastMillis = 0;
boolean dead = false;
double angularSpeed = 0;
int currentRead;
long currentMillis;
double currentPosition;
int updatesPerRotation;
double inchesTravelled = 0;
double currentSpeed = 0;
double averageSpeed = 0;
double maxSpeed = 0;
double numberOfRotations = 0;

//These arrays define the "pixels" on the rotating wheel
//For now, this data is always what is used when the wheel first turns on
//More work is needed to store uploaded patterns in persistant memory
//See Flash Storage information at arduino.cc
boolean ring1[123] = {true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,false,false,true,true,false,false,true,false,false,true,false,false,true,true,false,false,true,true,true,true,false,true,false,false,true,false,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,false,true,true,true,false,false,true,false,false,true,false,true,true,false,false,false,false,true,true,false,false,true,true,true,true,false,true,true,true,true,false,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true};
boolean ring2[123] = {false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,true,true,false,false,true,false,false,true,false,true,true,true,true,false,true,true,true,true,false,true,false,false,true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,true,true,true,true,false,true,false,false,true,false,true,true,true,false,false,true,true,true,true,false,true,true,true,true,false,true,true,true,true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false};
boolean ring3[123] = {false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,true,true,false,false,true,false,false,true,false,true,false,false,true,false,false,true,true,false,false,true,true,false,true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,true,false,false,true,false,true,false,false,true,false,true,false,true,false,false,true,false,false,true,false,false,false,false,true,false,false,false,false,true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false};
boolean ring4[123] = {false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,true,true,false,false,true,false,false,true,false,true,true,false,true,false,false,true,true,false,false,true,true,false,true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,true,false,false,true,false,true,false,false,true,false,true,false,false,true,false,true,false,false,true,false,false,false,true,true,false,false,false,true,true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false};
boolean ring5[123] = {false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,true,true,false,false,false,true,true,true,false,true,true,false,true,false,false,true,true,false,false,true,true,false,true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,true,true,true,true,false,true,true,true,true,false,true,false,false,true,false,true,true,true,true,false,false,false,true,false,false,false,false,true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false};
boolean ring6[123] = {false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,true,true,false,false,true,true,true,true,false,false,false,false,true,false,false,true,true,false,false,true,false,true,true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,true,true,true,false,false,false,true,true,false,false,true,false,false,true,false,true,true,true,true,false,false,true,false,false,false,false,true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false};
boolean ring7[123] = {false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,true,true,false,false,true,false,false,true,false,false,false,false,true,false,false,true,true,false,false,true,false,true,true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,true,true,false,false,false,false,true,true,false,false,true,false,false,true,false,true,false,false,true,false,true,true,false,false,false,true,true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false};
boolean ring8[123] = {false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,true,true,false,false,true,false,false,true,false,true,false,false,true,false,false,true,true,false,false,true,false,true,true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,true,true,true,false,false,false,true,true,false,false,true,false,true,false,false,true,false,false,true,false,true,false,false,false,false,true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false};
boolean ring9[123] = {false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,true,true,true,true,false,true,false,false,true,false,true,true,true,true,false,true,true,true,true,false,true,false,false,true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,true,false,true,true,false,false,true,true,false,false,true,true,true,false,false,true,false,false,true,false,true,true,true,true,false,true,true,true,true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false};
boolean ring10[123] = {true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,false,true,true,true,true,false,true,false,false,true,false,false,true,true,false,false,true,true,true,true,false,true,false,false,true,false,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,false,true,false,false,true,false,false,true,true,false,false,true,true,false,false,false,true,false,false,true,false,true,true,true,true,false,true,true,true,true,false,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true};
boolean* rings[10] = {ring1, ring2, ring3, ring4, ring5, ring6, ring7, ring8, ring9, ring10};
int sizes[10] = {123,123,123,123,123,123,123,123,123,123};

void setup() {  
  Serial.begin(57600);
  for (int i = 2; i < 12; i++)
    pinMode(i, OUTPUT);
  pinMode(12, INPUT);
  pinMode(13, OUTPUT);
  lastMillis = millis();
  lastUpdate = millis();
}

void loop() {
  checkSpin();
  if (dead) {
    checkInput();
  }
  else {
    updateSpeed();
    determinePosition();
    lightPixels();
  }
}

//Checks for serial input
void checkInput() {
  //Commands: 
  //'c' = current information
  //'t' = trip totals
  //'u' = update - this then waits for a string of chararacters to update the
  //      pixel arrays
  if (Serial.available()) {
    byte command = Serial.read();
    if (command == 'c') {
      if (dead) Serial.println("Dead.");
      Serial.println(angularSpeed);
    }
    else if (command == 't') {
      Serial.println("Your Trip Information (since last reset):");
      Serial.print("Distance Travelled: ");
      Serial.print(inchesTravelled);
      Serial.print(" inches, or ");
      Serial.print(inchesTravelled/(12.0 * 5280.0));
      Serial.println(" miles.");
      Serial.print("Average speed: ");
      Serial.print(averageSpeed);
      Serial.print(" inches per second, or ");
      Serial.print(averageSpeed/(12.0 * 5280.0));
      Serial.println(" miles per hour.");
      Serial.print("Max speed: ");
      Serial.print(maxSpeed);
      Serial.print(" inches per second, or ");
      Serial.print(maxSpeed/(12.0 * 5280.0));
      Serial.println(" miles per hour.");
    }
    else if (command == 'u') {
      //This data does not currently persist, needs more work to store it
      //in non-volatile memory.
      int count = 0;
      byte character;
      resetPixels();
      while(count < 1229){    
        if (Serial.available()) {    
          character = Serial.read();
          if (character == 'q') break;
          if (character == '1'){
            Serial.print(count/123);
            Serial.print(", ");
            Serial.println(count - (123 * (count/123)));
            setPixel(count/123, count - (123*(count/123)));
          }
          count++;
          digitalWrite(count/10 + 2, HIGH);
          if (count % 100 == 0) Serial.println(count);         
        }
      }
      delay(1000);
    }
  }
}

//Checks to see if the wheel is spinning (has passed the magnets in the last second)
void checkSpin() {
  currentRead = digitalRead(12);
  currentMillis = millis();
  if (currentRead == lastRead) {
    if (currentMillis - lastMillis > 1000) {
      dead = true;
      lastMillis = currentMillis;
    }
  }
  else {
    dead = false;
    lastMillis = currentMillis;
  }
  if (dead) {
    setDead();
  }  
}

//Turns off all lights
void resetAll() {
  for (int i = 2; i < 12; i++) {
    digitalWrite(i, LOW);
  }
}

//Updates the speed of the wheel
void updateSpeed() {
  if (currentRead == LOW && currentRead != lastRead) {
      currentPosition = 0;
      long time = currentMillis - lastUpdate;
      lastUpdate = currentMillis;
      angularSpeed = (100.0) / (time / 1000.0);
      currentSpeed = angularSpeed * 0.8482300165;
    } 
    lastRead = currentRead;
}

//The "dead" pattern - flashes lights when wheel is not spinning
void setDead() {
  if (currentMillis - lastDeadFlash < 50) {
  digitalWrite(2, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 100) {
    digitalWrite(2, LOW);
    digitalWrite(3, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 150) {
    digitalWrite(3, LOW);
    digitalWrite(4, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 200) {
    digitalWrite(4, LOW);
    digitalWrite(5, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 250) {
    digitalWrite(5, LOW);
    digitalWrite(6, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 300) {
    digitalWrite(6, LOW);
    digitalWrite(7, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 350) {
    digitalWrite(7, LOW);
    digitalWrite(8, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 400) {
    digitalWrite(8, LOW);
    digitalWrite(9, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 450) {
    digitalWrite(9, LOW);
    digitalWrite(10, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 500) {
    digitalWrite(10, LOW);
    digitalWrite(11, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 550) {
    digitalWrite(11, LOW);
    digitalWrite(10, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 600) {
    digitalWrite(10, LOW);
    digitalWrite(9, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 650) {
    digitalWrite(9, LOW);
    digitalWrite(8, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 700) {
    digitalWrite(8, LOW);
    digitalWrite(7, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 750) {
    digitalWrite(7, LOW);
    digitalWrite(6, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 800) {
    digitalWrite(6, LOW);
    digitalWrite(5, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 850) {
    digitalWrite(5, LOW);
    digitalWrite(4, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 900) {
    digitalWrite(4, LOW);
    digitalWrite(3, HIGH);
  }
  else if (currentMillis - lastDeadFlash < 950) {
    digitalWrite(3, LOW);
  }
  else {
    lastDeadFlash = currentMillis;
    currentPosition = 0;
  }
}

//Sets pixel data
//valid x: 0 through 9
//valid y: 0 through sizes[x]
void setPixel(int x, int y) {
  if (x < 0 || x > 9) {
    Serial.print("Invalid x: ");
    Serial.println(x);
  }
  else if (y >= sizes[x]) {
    Serial.print("Invalid y: ");
    Serial.println(y);
  }
  else {
    rings[x][y] = true;
  }
}

//Clears all pixel data to prepare for upload
void resetPixels() {
  for (int i = 0; i < 10; i++) {
    for (int j = 0; j < sizes[i]; j++) {
      rings[i][j] = 0;
    }
  }
}


void determinePosition() {
  long changeInTime = currentMillis - lastUpdate;
  double changeInPosition = (angularSpeed) * (changeInTime/1000.0);
  currentPosition = changeInPosition;
}

void lightPixels() {
  for(int i = 0; i < 10 && currentPosition <= 100; i++){
    boolean* pointer = rings[i];
    boolean b = pointer[(int)(sizes[i] * (currentPosition/100.0))];
    if(b){
      digitalWrite(i + 2, HIGH);
    }
    else {
      digitalWrite(i + 2, LOW);
    }
  }
  updatesPerRotation++;
}
